// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef ACCELEROMETER_APB_WRAPPER_HH
#define ACCELEROMETER_APB_WRAPPER_HH

#include <cstddef>
#include <stdint.h>
#include "hif_globals.hpp"

class accelerometer_apb_wrapper
{

public:

    bool analog_clock_old;
    uint32_t pwdata_old;
    bool pwrite_old;
    bool penable_old;
    bool psel_old;
    uint32_t paddr_old;
    bool presetn_old;
    bool pclk_old;
    struct accelerometer_apb_wrapper_iostruct{
        bool * pclk;
        bool * presetn;
        uint32_t * paddr;
        bool * psel;
        bool * penable;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;
        bool * analog_clock;

        accelerometer_apb_wrapper_iostruct():
            pclk(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            psel(nullptr),
            penable(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr),
            analog_clock(nullptr)
        {}

        accelerometer_apb_wrapper_iostruct( bool * pclk_0, bool * presetn_0, uint32_t
             * paddr_0, bool * psel_0, bool * penable_0, bool * pwrite_0, uint32_t
             * pwdata_0, bool * pready_0, uint32_t * prdata_0, bool * analog_clock_0
             ):
            pclk(pclk_0),
            presetn(presetn_0),
            paddr(paddr_0),
            psel(psel_0),
            penable(penable_0),
            pwrite(pwrite_0),
            pwdata(pwdata_0),
            pready(pready_0),
            prdata(prdata_0),
            analog_clock(analog_clock_0)
        {}

        ~accelerometer_apb_wrapper_iostruct()
        {}

        bool operator == (const accelerometer_apb_wrapper_iostruct & other) const
        {
            if (pclk != other.pclk) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (psel != other.psel) return false;
            if (penable != other.penable) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            if (analog_clock != other.analog_clock) return false;
            return true;
        }
    };
    accelerometer_apb_wrapper_iostruct hif_a2t_data;
    uint32_t prdata_var;
    double ddt_7;
    double ddt_6;
    double ddt_5;
    double ddt_4;
    double ddt_3;
    double ddt_2;
    double ddt_1;
    double ddt_0;
    double ddt;
    uint8_t cap7_d;
    uint8_t cap7_d_var;
    uint8_t cap5_d;
    uint8_t cap5_d_var;
    uint8_t cap2_d;
    uint8_t cap2_d_var;
    uint8_t cap1_d;
    uint8_t cap1_d_var;
    double acc_cap7_sample;
    double acc_cap5_sample;
    double acc_cap2_sample;
    double acc_cap1_sample;
    bool acc_cap7_over;
    bool acc_cap5_over;
    bool acc_cap2_over;
    bool acc_cap1_over;
    int32_t acc_i;

    // List of branch variables.
    AnalogPair b_avx;
    AnalogPair b_avy;
    AnalogPair b_avz;
    AnalogPair b_acc_reduced_0;
    AnalogPair b_acc_reduced_1;
    AnalogPair b_acc_reduced_0_dot;
    AnalogPair b_acc_reduced_1_dot;
    AnalogPair b_acc_avx_dot;
    AnalogPair b_acc_avy_dot;
    AnalogPair b_acc_avz_dot;
    AnalogPair b_acc_Cap1;
    AnalogPair b_acc_Cap2;
    AnalogPair b_acc_Cap5;
    AnalogPair b_acc_Cap7;
    accelerometer_apb_wrapper();


    ~accelerometer_apb_wrapper();


    uint8_t cap7_d_new;
    uint8_t cap5_d_new;
    uint8_t cap2_d_new;
    uint8_t cap1_d_new;
    bool process_in_queue;
    bool flag_analog_clock;
    bool flag_process_1_acc_process_executed;
    bool flag_pos_pclk;

    void process_2_acc_process_0();


    void process_1_acc_process();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    accelerometer_apb_wrapper( const accelerometer_apb_wrapper & );
    const accelerometer_apb_wrapper& operator= ( const accelerometer_apb_wrapper
         & );


};


#endif

